diff -Nru t1lib-grace/T1lib/t1lib/t1x11.h t1lib-deb/T1lib/t1lib/t1x11.h
--- t1lib-grace/T1lib/t1lib/t1x11.h	1969-12-31 16:00:00.000000000 -0800
+++ t1lib-deb/T1lib/t1lib/t1x11.h	2007-12-23 07:49:42.000000000 -0800
@@ -0,0 +1,103 @@
+/*--------------------------------------------------------------------------
+  ----- File:        t1x11.h
+  ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
+  ----- Date:        2003-01-02
+  ----- Description: This file is part of the t1-library. It contains
+                     definitions and declarations for t1x11.c.
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2003. 
+                     As of version 0.5, t1lib is distributed under the
+		     GNU General Public Library Lincense. The
+		     conditions can be found in the files LICENSE and
+		     LGPL, which should reside in the toplevel
+		     directory of the distribution.  Please note that 
+		     there are parts of t1lib that are subject to
+		     other licenses:
+		     The parseAFM-package is copyrighted by Adobe Systems
+		     Inc.
+		     The type1 rasterizer is copyrighted by IBM and the
+		     X11-consortium.
+  ----- Warranties:  Of course, there's NO WARRANTY OF ANY KIND :-)
+  ----- Credits:     I want to thank IBM and the X11-consortium for making
+                     their rasterizer freely available.
+		     Also thanks to Piet Tutelaers for his ps2pk, from
+		     which I took the rasterizer sources in a format
+		     independent from X11.
+                     Thanks to all people who make free software living!
+--------------------------------------------------------------------------*/
+
+#include <X11/Xlib.h>
+
+#ifdef T1X11_C
+
+int T1_SetX11Params( Display *display,
+		     Visual *visual,
+		     unsigned int depth,
+		     Colormap colormap);
+GLYPH *T1_SetCharX( Drawable d, GC gc, int mode, int x, int y,
+		    int FontID, char charcode,
+		    float size, T1_TMATRIX *transform);
+GLYPH *T1_SetStringX( Drawable d, GC gc, int mode, int x, int y,
+		      int FontID, char *string, int len,
+		      long spaceoff, int modflag,
+		      float size, T1_TMATRIX *transform);
+GLYPH *T1_SetRectX( Drawable d, GC gc, int mode, int x_dest, int y_dest,
+		    int FontID, float size,
+		    float width, float height,
+		    T1_TMATRIX *transform);
+GLYPH *T1_AASetCharX( Drawable d, GC gc, int mode, int x, int y,
+		      int FontID, char charcode,
+		      float size, T1_TMATRIX *transform);
+GLYPH *T1_AASetStringX( Drawable d, GC gc, int mode, int x, int y,
+			int FontID, char *string, int len,
+			long spaceoff, int modflag,
+			float size, T1_TMATRIX *transform);
+GLYPH *T1_AASetRectX( Drawable d, GC gc, int mode, int x_dest, int y_dest,
+		      int FontID, float size,
+		      float width, float height,
+		      T1_TMATRIX *transform);
+int T1_ComputeAAColorsX( unsigned long fg,
+			 unsigned long bg,
+			 int nolevels);
+int T1_GetDepthOfDrawable( Drawable drawable);
+void T1_LogicalPositionX( int pos_switch);
+
+
+#else
+
+extern Display *T1_display;
+
+extern int T1_SetX11Params( Display *display,
+			    Visual *visual,
+			    unsigned int depth,
+			    Colormap colormap);
+extern GLYPH *T1_SetCharX( Drawable d, GC gc, int mode, int x, int y,
+			   int FontID, char charcode,
+			   float size, T1_TMATRIX *transform);
+extern GLYPH *T1_SetStringX( Drawable d, GC gc, int mode, int x, int y,
+			     int FontID, char *string, int len,
+			     long spaceoff, int modflag,
+			     float size, T1_TMATRIX *transform);
+extern GLYPH *T1_SetRectX( Drawable d, GC gc, int mode, int x_dest, int y_dest,
+			   int FontID, float size,
+			   float width, float height,
+			   T1_TMATRIX *transform);
+extern GLYPH *T1_AASetCharX( Drawable d, GC gc, int mode, int x, int y,
+			     int FontID, char charcode,
+			     float size, T1_TMATRIX *transform);
+extern GLYPH *T1_AASetStringX( Drawable d, GC gc, int mode, int x, int y,
+			       int FontID, char *string, int len,
+			       long spaceoff, int modflag,
+			       float size, T1_TMATRIX *transform);
+extern GLYPH *T1_AASetRectX( Drawable d, GC gc, int mode, int x_dest, int y_dest,
+			     int FontID, float size,
+			     float width, float height,
+			     T1_TMATRIX *transform);
+extern int T1_ComputeAAColorsX( unsigned long fg,
+				unsigned long bg,
+				int nolevels);
+extern int T1_GetDepthOfDrawable( Drawable drawable);
+extern void T1_LogicalPositionX( int pos_switch);
+
+
+#endif
+
diff -Nru t1lib-grace/T1lib/type1/.dependencies t1lib-deb/T1lib/type1/.dependencies
--- t1lib-grace/T1lib/type1/.dependencies	2002-01-03 13:15:17.000000000 -0800
+++ t1lib-deb/T1lib/type1/.dependencies	2007-12-23 07:49:42.000000000 -0800
@@ -4,18 +4,18 @@
  curves.h lines.h arith.h
 fontfcn.lo: fontfcn.c t1imager.h types.h fontmisc.h util.h fontfcn.h \
  paths_rmz.h spaces_rmz.h ../t1lib/parseAFM.h ../t1lib/t1types.h \
- ../t1lib/t1extern.h ../t1lib/t1misc.h ../t1lib/t1base.h \
- ../t1lib/t1finfo.h
+ ../t1lib/sysconf.h ../t1lib/t1extern.h ../t1lib/t1misc.h \
+ ../t1lib/t1base.h ../t1lib/t1finfo.h
 hints.lo: hints.c types.h objects.h spaces.h paths.h regions.h hints.h
-lines.lo: lines.c types.h objects.h spaces.h regions.h lines.h
+lines.lo: lines.c types.h objects.h spaces.h paths.h regions.h lines.h
 objects.lo: objects.c types.h objects.h spaces.h paths.h regions.h \
  fonts.h pictures.h strokes.h cluts.h
 paths.lo: paths.c types.h objects.h spaces.h paths.h regions.h fonts.h \
  pictures.h strokes.h trig.h
-regions.lo: regions.c types.h objects.h spaces.h regions.h paths.h \
+regions.lo: regions.c types.h objects.h spaces.h paths.h regions.h \
  curves.h lines.h pictures.h fonts.h hints.h strokes.h
 scanfont.lo: scanfont.c t1stdio.h types.h util.h token.h fontfcn.h \
- blues.h
+ blues.h ../t1lib/t1misc.h
 spaces.lo: spaces.c types.h objects.h spaces.h paths.h pictures.h \
  fonts.h arith.h trig.h
 t1io.lo: t1io.c t1stdio.h types.h t1hdigit.h
diff -Nru t1lib-grace/T1lib/type1/fontfcn.c t1lib-deb/T1lib/type1/fontfcn.c
--- t1lib-grace/T1lib/type1/fontfcn.c	2002-01-03 13:15:17.000000000 -0800
+++ t1lib-deb/T1lib/type1/fontfcn.c	2007-12-23 07:49:42.000000000 -0800
@@ -46,16 +46,24 @@
 #include "../t1lib/t1base.h"
 #include "../t1lib/t1finfo.h"
 
+/* Note: The argument decodeonly is used to make Type1Char() decode only
+         such that later certain characterictics of the pass can be queried
+	 (here, information about the parts of a seac).
+*/
 extern xobject Type1Char(psfont *env, struct XYspace *S,
 			 psobj *charstrP, psobj *subrsP,
 			 psobj *osubrsP,
 			 struct blues_struct *bluesP,
-			 int *modeP, char *name);
+			 int *modeP, char *name,
+			 float strokewidth,
+			 int decodeonly);
 extern xobject Type1Line(psfont *env, struct XYspace *S,
-				 float line_position,
-				 float line_thickness,
-				 float line_length);
-extern  boolean Init_BuiltInEncoding( void);
+			 float line_position,
+			 float line_thickness,
+			 float line_length,
+			 float strokewidth);
+extern int T1int_Type1QuerySEAC( unsigned char* base,
+				 unsigned char* accent);
 void objFormatName(psobj *objP, int length, char *valueP);
   
 extern void T1io_reset( void);
@@ -64,13 +72,49 @@
 #define LINETYPE   0x10+0x00
 #define MOVETYPE   0x10+0x05
 
+#if 1
+struct region {
+  XOBJ_COMMON           /* xobject common data define 3-26-91 PNM    */
+  /* type = REGIONTYPE                         */
+  struct fractpoint origin;    /* beginning handle:  X,Y origin of region      */
+  struct fractpoint ending;    /* ending handle:  X,Y change after painting region */
+  pel xmin,ymin;        /* minimum X,Y of region                        */
+  pel xmax,ymax;        /* mat1_mum X,Y of region                        */
+  struct edgelist *anchor;  /* list of edges that bound the region      */
+  struct picture *thresholded;  /* region defined by thresholded picture*/
+  /*
+    Note that the ending handle and the bounding box values are stored
+    relative to 'origin'.
+    
+    The above elements describe a region.  The following elements are
+    scratchpad areas used while the region is being built:
+  */
+  fractpel lastdy;      /* direction of last segment                    */
+  fractpel firstx,firsty;    /* starting point of current edge          */
+  fractpel edgexmin,edgexmax;  /* x extent of current edge              */
+  struct edgelist *lastedge,*firstedge;  /* last and first edges in subpath */
+  pel *edge;            /* pointer to array of X values for edge        */
+  fractpel edgeYstop;   /* Y value where 'edges' array ends             */
+  int (*newedgefcn)();  /* function to use when building a new edge     */
+  struct strokeinfo *strokeinfo;  /* scratchpad info during stroking only */
+} ;
+struct edgelist {
+  XOBJ_COMMON          /* xobject common data define 3-26-91 PNM        */
+  /* type = EDGETYPE                               */
+  struct edgelist *link;  /* pointer to next in linked list             */
+  struct edgelist *subpath;  /* informational link for "same subpath"   */
+  pel xmin,xmax;        /* range of edge in X                           */
+  pel ymin,ymax;        /* range of edge in Y                           */
+  pel *xvalues;         /* pointer to ymax-ymin X values                */
+};
+#endif
 
 /***================================================================***/
 /*   GLOBALS                                                          */
 /***================================================================***/
 static char CurCharName[257]="";
 static char BaseCharName[257]="";
-char CurFontName[120];
+char CurFontName[MAXPATHLEN+1];
 char *CurFontEnv;
 char *vm_base = NULL;
 
@@ -119,7 +163,6 @@
 {
   if (!(vm_init())) return(FALSE);
   vm_base = vm_next_byte();
-  if (!(Init_BuiltInEncoding())) return(FALSE);
   strcpy(CurFontName, "");    /* iniitialize to none */
   FontP->vm_start = vm_next_byte();
   FontP->FontFileName.len = 0;
@@ -140,7 +183,8 @@
   FontP->fontInfoP = NULL;
   FontP->BluesP = NULL;
   /* This will load the font into the FontP */
-  strcpy(CurFontName,env);
+  strncpy(CurFontName,env, MAXPATHLEN);
+  CurFontName[MAXPATHLEN] = '\0';
   FontP->FontFileName.len = strlen(CurFontName);
   FontP->FontFileName.data.nameP = CurFontName;
   T1io_reset();
@@ -241,7 +285,8 @@
 		 struct XYspace *S, char **ev,
 		 unsigned char index, int *mode,
 		 psfont *Font_Ptr,
-		 int do_raster)
+		 int do_raster,
+		 float strokewidth)
 {
  
   psobj *charnameP; /* points to psobj that is name of character*/
@@ -337,7 +382,7 @@
   /* get CharString and character path */
   theStringP = &(CharStringsDictP[basechar].value);
   tmppath2 = (struct segment *) Type1Char(FontP,S,theStringP,SubrsArrayP,NULL,
-					  FontP->BluesP,mode,CurCharName);
+					  FontP->BluesP,mode,CurCharName,strokewidth,0);
   /* if Type1Char reported an error, then return */
   if ( *mode == FF_PARSE_ERROR || *mode==FF_PATH_ERROR)
     return(NULL);
@@ -378,7 +423,7 @@
     strncpy( (char *)CurCharName, (char *)charnameP->data.stringP, charnameP->len);
     CurCharName[charnameP->len]='\0';
     charpath=(struct segment *)Type1Char(FontP,S,theStringP,SubrsArrayP,NULL,
-					 FontP->BluesP,mode,CurCharName);
+					 FontP->BluesP,mode,CurCharName,strokewidth,0);
     /* return if Type1Char reports an error */
     if ( *mode == FF_PARSE_ERROR || *mode==FF_PATH_ERROR)
       return(NULL);
@@ -593,7 +638,8 @@
 			 unsigned char *string, int no_chars,
 			 int *mode, psfont *Font_Ptr,
 			 int *kern_pairs, long spacewidth,
-			 int do_raster)
+			 int do_raster,
+			 float strokewidth)
 {
  
   psobj *charnameP; /* points to psobj that is name of character*/
@@ -714,7 +760,7 @@
       /* get CharString and character path */
       theStringP = &(CharStringsDictP[basechar].value);
       tmppath2 = (struct segment *) Type1Char(FontP,S,theStringP,SubrsArrayP,NULL,
-					      FontP->BluesP,mode,CurCharName);
+					      FontP->BluesP,mode,CurCharName,strokewidth,0);
       strcpy( BaseCharName, CurCharName);
       /* if Type1Char reports an error, clean up and return */
       if ( *mode == FF_PARSE_ERROR || *mode==FF_PATH_ERROR) {
@@ -790,7 +836,7 @@
 	strncpy( (char *)CurCharName, (char *)charnameP->data.stringP, charnameP->len);
 	CurCharName[charnameP->len]='\0';
 	tmppath5=(struct segment *)Type1Char(FontP,S,theStringP,SubrsArrayP,NULL,
-					     FontP->BluesP,mode,CurCharName);
+					     FontP->BluesP,mode,CurCharName,strokewidth,0);
 	/* return if Type1Char reports an error */
 	if ( *mode == FF_PARSE_ERROR || *mode==FF_PATH_ERROR)
 	  return(NULL);
@@ -873,21 +919,21 @@
     tmppath2=(struct segment *)Type1Line(FontP,S,
 					 pFontBase->pFontArray[FontID].UndrLnPos,
 					 pFontBase->pFontArray[FontID].UndrLnThick,
-					 (float) acc_width);
+					 (float) acc_width,strokewidth);
     charpath=(struct segment *)Join(charpath,tmppath2);
   }
   if (modflag & T1_OVERLINE){
     tmppath2=(struct segment *)Type1Line(FontP,S,
 					 pFontBase->pFontArray[FontID].OvrLnPos,
 					 pFontBase->pFontArray[FontID].OvrLnThick,
-					 (float) acc_width);
+					 (float) acc_width,strokewidth);
     charpath=(struct segment *)Join(charpath,tmppath2);
   }
   if (modflag & T1_OVERSTRIKE){
     tmppath2=(struct segment *)Type1Line(FontP,S,
 					 pFontBase->pFontArray[FontID].OvrStrkPos,
 					 pFontBase->pFontArray[FontID].OvrStrkThick,
-					 (float) acc_width);
+					 (float) acc_width,strokewidth);
     charpath=(struct segment *)Join(charpath,tmppath2);
   }
   
@@ -1012,7 +1058,7 @@
   /* get CharString and character path */
   theStringP = &(CharStringsDictP[basechar].value);
   tmppath2 = (struct segment *) Type1Char(FontP,S,theStringP,SubrsArrayP,NULL,
-					  FontP->BluesP,mode,CurCharName);
+					  FontP->BluesP,mode,CurCharName, 0.0f, 0);
   /* if Type1Char reported an error, then return */
   if ( *mode == FF_PARSE_ERROR || *mode==FF_PATH_ERROR)
     return(NULL);
@@ -1053,7 +1099,7 @@
     strncpy( (char *)CurCharName, (char *)charnameP->data.stringP, charnameP->len);
     CurCharName[charnameP->len]='\0';
     charpath=(struct segment *)Type1Char(FontP,S,theStringP,SubrsArrayP,NULL,
-					 FontP->BluesP,mode,CurCharName);
+					 FontP->BluesP,mode,CurCharName,0.0f,0);
     /* return if Type1Char reports an error */
     if ( *mode == FF_PARSE_ERROR || *mode==FF_PATH_ERROR)
       return(NULL);
@@ -1103,3 +1149,118 @@
 
 }
 
+
+xobject fontfcnRect( float width,
+		     float height,
+		     struct XYspace* S,
+		     int *mode,
+		     int do_raster,
+		     float strokewidth)
+{
+  struct segment *charpath = NULL;   /* the path for this character (rectangle)  */           
+  
+  charpath = (struct segment *) Type1Line( NULL, S,
+					   0.5f * height,    /* position */
+					   height,           /* thickness */
+					   -width,            /* width */
+					   strokewidth       /* strokewidth */
+					   );
+  
+  if (do_raster) { 
+    /* fill with winding rule unless path was requested */
+    if (*mode != FF_PATH) {
+      charpath =  (struct segment *)Interior(charpath,WINDINGRULE+CONTINUITY);
+    }
+  }
+
+  return((xobject) charpath);
+  
+}
+
+
+
+/* T1int_QuerySEAC(): Query for Type of character definition of index "index".
+
+   Returns: 0     if charstring for currenc[index] not defined
+            1     if charstring defines a self-containing character
+	    2     if charstring references other definition by means of
+	          the SEAC directive.
+*/
+int T1int_QuerySEAC( int FontID, 
+		     unsigned char index,
+		     unsigned char* basepiece,
+		     unsigned char* accpiece
+		     )
+{
+  
+  psobj *charnameP; /* points to psobj that is name of character*/
+  int thischar;
+  int mode = 0;
+  
+  psdict *CharStringsDictP; /* dictionary with char strings     */
+  psobj   CodeName;   /* used to store the translation of the name*/
+  psobj  *SubrsArrayP;
+  psobj  *theStringP;
+  char **ev;
+  struct XYspace *S;
+  struct segment *path=NULL;   /* the path for this character   */           
+  
+   
+  /* set the global font pointer to the address of already allocated
+     structure and setup pointers*/
+  FontP=pFontBase->pFontArray[FontID].pType1Data;
+  CharStringsDictP =  FontP->CharStringsP;
+  SubrsArrayP = &(FontP->Subrs);
+  charnameP = &CodeName;
+
+  /* get encoding */
+  ev=pFontBase->pFontArray[FontID].pFontEnc;
+
+  if (ev==NULL){  /* font-internal encoding should be used */
+    charnameP->len = FontP->fontInfoP[ENCODING].value.data.arrayP[index].len;
+    charnameP->data.stringP = (unsigned char *) FontP->fontInfoP[ENCODING].value.data.arrayP[index].data.arrayP;
+  }
+  else{           /* some user-supplied encoding is to be used */
+    charnameP->len = strlen(ev[index]);
+    charnameP->data.stringP = (unsigned char *) ev[index];
+  }
+  strncpy( (char *)CurCharName, (char *)charnameP->data.stringP, charnameP->len);
+  CurCharName[charnameP->len]='\0';
+  
+ 
+  /* search the chars string for this charname as key */
+  thischar = SearchDictName(CharStringsDictP,charnameP);
+  /* thischar is now the index of the base character in the CharStrings
+     dictionary */
+
+  if ( thischar <= 0 ) {
+    /* CharString not defined, return */
+    return 0;
+  }
+
+  /* Setup NULL-space, not needed when paths aren't created */
+  S = NULL; 
+      
+  
+  /* we provide the Type1Char() procedure with the name of the character
+     to rasterize for debugging purposes */
+  strncpy( (char *)CurCharName, (char *)charnameP->data.stringP, charnameP->len);
+  CurCharName[charnameP->len]='\0';
+  /* get CharString and character path */
+  theStringP = &(CharStringsDictP[thischar].value);
+  
+  path = (struct segment *) Type1Char(FontP,S,theStringP,SubrsArrayP,NULL,
+				      FontP->BluesP,&mode,CurCharName,0, 1);
+
+  /* if Type1Char reported an error, then return */
+  if ( mode == FF_PARSE_ERROR || mode==FF_PATH_ERROR) {
+    return -1;
+  }
+
+  if ( T1int_Type1QuerySEAC( basepiece, accpiece) > 0 ) {
+    return 2;
+  }
+
+  return 1;
+
+}
diff -Nru t1lib-grace/T1lib/type1/fontstruct.h t1lib-deb/T1lib/type1/fontstruct.h
--- t1lib-grace/T1lib/type1/fontstruct.h	1999-09-07 13:51:21.000000000 -0700
+++ t1lib-deb/T1lib/type1/fontstruct.h	2007-12-23 07:49:42.000000000 -0800
@@ -1,4 +1,4 @@
-/* $Header: /home/fnevgeny/cvsroot/grace/T1lib/type1/fontstruct.h,v 1.3 1999/09/07 20:51:21 fnevgeny Exp $ */
+/* $Header: fontstruct.h,v 1.10 91/07/22 15:37:41 keith Exp $ */
 /***********************************************************
 Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,
 and the Massachusetts Institute of Technology, Cambridge, Massachusetts.
